package/sdl2: enable OpenGL ES support
[buildroot-gz.git] / toolchain / helpers.mk
blob72e7292353882f96a754c3d9312e616e191f726f
1 # This Makefile fragment declares toolchain related helper functions.
3 # The copy_toolchain_lib_root function copies a toolchain library and
4 # its symbolic links from the sysroot directory to the target
5 # directory. Note that this function is used both by the external
6 # toolchain logic, and the glibc package, so care must be taken when
7 # changing this function.
9 # $1: library name
11 copy_toolchain_lib_root = \
12 LIB="$(strip $1)"; \
14 LIBPATHS=`find $(STAGING_DIR)/ -name "$${LIB}" 2>/dev/null` ; \
15 for LIBPATH in $${LIBPATHS} ; do \
16 DESTDIR=`echo $${LIBPATH} | sed "s,^$(STAGING_DIR)/,," | xargs dirname` ; \
17 mkdir -p $(TARGET_DIR)/$${DESTDIR}; \
18 while true ; do \
19 LIBNAME=`basename $${LIBPATH}`; \
20 LIBDIR=`dirname $${LIBPATH}` ; \
21 LINKTARGET=`readlink $${LIBPATH}` ; \
22 rm -fr $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME}; \
23 if test -h $${LIBPATH} ; then \
24 ln -sf `basename $${LINKTARGET}` $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME} ; \
25 elif test -f $${LIBPATH}; then \
26 $(INSTALL) -D -m0755 $${LIBPATH} $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME}; \
27 else \
28 exit -1; \
29 fi; \
30 if test -z "$${LINKTARGET}" ; then \
31 break ; \
32 fi ; \
33 LIBPATH="`readlink -f $${LIBPATH}`"; \
34 done; \
35 done
38 # Copy the full external toolchain sysroot directory to the staging
39 # dir. The operation of this function is rendered a little bit
40 # complicated by the support for multilib toolchains.
42 # We start by copying etc, lib, sbin and usr from the sysroot of the
43 # selected architecture variant (as pointed by ARCH_SYSROOT_DIR). This
44 # allows to import into the staging directory the C library and
45 # companion libraries for the correct architecture variant. We
46 # explictly only copy etc, lib, sbin and usr since other directories
47 # might exist for other architecture variants (on Codesourcery
48 # toolchain, the sysroot for the default architecture variant contains
49 # the armv4t and thumb2 subdirectories, which are the sysroot for the
50 # corresponding architecture variants), and we don't want to import
51 # them.
53 # Then, if the selected architecture variant is not the default one
54 # (i.e, if SYSROOT_DIR != ARCH_SYSROOT_DIR), then we :
56 # * Import the header files from the default architecture
57 # variant. Header files are typically shared between the sysroots
58 # for the different architecture variants. If we use the
59 # non-default one, header files were not copied by the previous
60 # step, so we copy them here from the sysroot of the default
61 # architecture variant.
63 # * Create a symbolic link that matches the name of the subdirectory
64 # for the architecture variant in the original sysroot. This is
65 # required as the compiler will by default look in
66 # sysroot_dir/arch_variant/ for libraries and headers, when the
67 # non-default architecture variant is used. Without this, the
68 # compiler fails to find libraries and headers.
70 # Some toolchains (i.e Linaro binary toolchains) store support
71 # libraries (libstdc++, libgcc_s) outside of the sysroot, so we simply
72 # copy all the libraries from the "support lib directory" into our
73 # sysroot.
75 # Note that the 'locale' directories are not copied. They are huge
76 # (400+MB) in CodeSourcery toolchains, and they are not really useful.
78 # $1: main sysroot directory of the toolchain
79 # $2: arch specific sysroot directory of the toolchain
80 # $3: arch specific subdirectory in the sysroot
81 # $4: directory of libraries ('lib', 'lib32' or 'lib64')
82 # $5: support lib directories (for toolchains storing libgcc_s,
83 # libstdc++ and other gcc support libraries outside of the
84 # sysroot)
85 copy_toolchain_sysroot = \
86 SYSROOT_DIR="$(strip $1)"; \
87 ARCH_SYSROOT_DIR="$(strip $2)"; \
88 ARCH_SUBDIR="$(strip $3)"; \
89 ARCH_LIB_DIR="$(strip $4)" ; \
90 SUPPORT_LIB_DIR="$(strip $5)" ; \
91 for i in etc $${ARCH_LIB_DIR} sbin usr usr/$${ARCH_LIB_DIR}; do \
92 if [ -d $${ARCH_SYSROOT_DIR}/$$i ] ; then \
93 rsync -au --chmod=u=rwX,go=rX --exclude 'usr/lib/locale' \
94 --include '/libexec*/' --exclude '/lib*/' \
95 $${ARCH_SYSROOT_DIR}/$$i/ $(STAGING_DIR)/$$i/ ; \
96 fi ; \
97 done ; \
98 if [ `readlink -f $${SYSROOT_DIR}` != `readlink -f $${ARCH_SYSROOT_DIR}` ] ; then \
99 if [ ! -d $${ARCH_SYSROOT_DIR}/usr/include ] ; then \
100 cp -a $${SYSROOT_DIR}/usr/include $(STAGING_DIR)/usr ; \
101 fi ; \
102 mkdir -p `dirname $(STAGING_DIR)/$${ARCH_SUBDIR}` ; \
103 relpath="./" ; \
104 nbslashs=`printf $${ARCH_SUBDIR} | sed 's%[^/]%%g' | wc -c` ; \
105 for slash in `seq 1 $${nbslashs}` ; do \
106 relpath=$${relpath}"../" ; \
107 done ; \
108 ln -s $${relpath} $(STAGING_DIR)/$${ARCH_SUBDIR} ; \
109 echo "Symlinking $(STAGING_DIR)/$${ARCH_SUBDIR} -> $${relpath}" ; \
110 fi ; \
111 if test -n "$${SUPPORT_LIB_DIR}" ; then \
112 cp -a $${SUPPORT_LIB_DIR}/* $(STAGING_DIR)/lib/ ; \
113 fi ; \
114 find $(STAGING_DIR) -type d | xargs chmod 755
117 # Check the specified kernel headers version actually matches the
118 # version in the toolchain.
120 # $1: sysroot directory
121 # $2: kernel version string, in the form: X.Y
123 check_kernel_headers_version = \
124 if ! support/scripts/check-kernel-headers.sh $(1) $(2); then \
125 exit 1; \
129 # Check the specific gcc version actually matches the version in the
130 # toolchain
132 # $1: path to gcc
133 # $2: expected gcc version
135 # Some details about the sed expression:
136 # - 1!d
137 # - delete if not line 1
139 # - s/^[^)]+\) ([^[:space:]]+).*/\1/
140 # - eat all until the first ')' character followed by a space
141 # - match as many non-space chars as possible
142 # - eat all the remaining chars on the line
143 # - replace by the matched expression
145 check_gcc_version = \
146 expected_version="$(strip $2)" ; \
147 if [ -z "$${expected_version}" ]; then \
148 exit 0 ; \
149 fi; \
150 real_version=`$(1) --version | sed -r -e '1!d; s/^[^)]+\) ([^[:space:]]+).*/\1/;'` ; \
151 if [[ ! "$${real_version}" =~ ^$${expected_version}\. ]] ; then \
152 printf "Incorrect selection of gcc version: expected %s.x, got %s\n" \
153 "$${expected_version}" "$${real_version}" ; \
154 exit 1 ; \
158 # Check the availability of a particular glibc feature. This function
159 # is used to check toolchain options that are always supported by
160 # glibc, so we simply check that the corresponding option is properly
161 # enabled.
163 # $1: Buildroot option name
164 # $2: feature description
166 check_glibc_feature = \
167 if [ "$($(1))" != "y" ] ; then \
168 echo "$(2) available in C library, please enable $(1)" ; \
169 exit 1 ; \
173 # Check the availability of RPC support in a glibc toolchain
175 # $1: sysroot directory
177 check_glibc_rpc_feature = \
178 IS_IN_LIBC=`test -f $(1)/usr/include/rpc/rpc.h && echo y` ; \
179 if [ "$(BR2_TOOLCHAIN_HAS_NATIVE_RPC)" != "y" -a "$${IS_IN_LIBC}" = "y" ] ; then \
180 echo "RPC support available in C library, please enable BR2_TOOLCHAIN_EXTERNAL_INET_RPC" ; \
181 exit 1 ; \
182 fi ; \
183 if [ "$(BR2_TOOLCHAIN_HAS_NATIVE_RPC)" = "y" -a "$${IS_IN_LIBC}" != "y" ] ; then \
184 echo "RPC support not available in C library, please disable BR2_TOOLCHAIN_EXTERNAL_INET_RPC" ; \
185 exit 1 ; \
189 # Check the correctness of a glibc external toolchain configuration.
190 # 1. Check that the C library selected in Buildroot matches the one
191 # of the external toolchain
192 # 2. Check that all the C library-related features are enabled in the
193 # config, since glibc always supports all of them
195 # $1: sysroot directory
197 check_glibc = \
198 SYSROOT_DIR="$(strip $1)"; \
199 if test `find $${SYSROOT_DIR}/ -maxdepth 2 -name 'ld-linux*.so.*' -o -name 'ld.so.*' -o -name 'ld64.so.*' | wc -l` -eq 0 ; then \
200 echo "Incorrect selection of the C library"; \
201 exit -1; \
202 fi; \
203 $(call check_glibc_feature,BR2_USE_MMU,MMU support) ;\
204 $(call check_glibc_rpc_feature,$${SYSROOT_DIR})
207 # Check that the selected C library really is musl
209 # $1: sysroot directory
210 check_musl = \
211 SYSROOT_DIR="$(strip $1)"; \
212 if test ! -f $${SYSROOT_DIR}/lib/libc.so -o -e $${SYSROOT_DIR}/lib/libm.so ; then \
213 echo "Incorrect selection of the C library" ; \
214 exit -1; \
218 # Check the conformity of Buildroot configuration with regard to the
219 # uClibc configuration of the external toolchain, for a particular
220 # feature.
222 # If 'Buildroot option name' ($2) is empty it means the uClibc option
223 # is mandatory.
225 # $1: uClibc macro name
226 # $2: Buildroot option name
227 # $3: uClibc config file
228 # $4: feature description
230 check_uclibc_feature = \
231 IS_IN_LIBC=`grep -q "\#define $(1) 1" $(3) && echo y` ; \
232 if [ -z "$(2)" ] ; then \
233 if [ "$${IS_IN_LIBC}" != "y" ] ; then \
234 echo "$(4) not available in C library, toolchain unsuitable for Buildroot" ; \
235 exit 1 ; \
236 fi ; \
237 else \
238 if [ "$($(2))" != "y" -a "$${IS_IN_LIBC}" = "y" ] ; then \
239 echo "$(4) available in C library, please enable $(2)" ; \
240 exit 1 ; \
241 fi ; \
242 if [ "$($(2))" = "y" -a "$${IS_IN_LIBC}" != "y" ] ; then \
243 echo "$(4) not available in C library, please disable $(2)" ; \
244 exit 1 ; \
245 fi ; \
249 # Check the correctness of a uclibc external toolchain configuration
250 # 1. Check that the C library selected in Buildroot matches the one
251 # of the external toolchain
252 # 2. Check that the features enabled in the Buildroot configuration
253 # match the features available in the uClibc of the external
254 # toolchain
256 # $1: sysroot directory
258 check_uclibc = \
259 SYSROOT_DIR="$(strip $1)"; \
260 if ! test -f $${SYSROOT_DIR}/usr/include/bits/uClibc_config.h ; then \
261 echo "Incorrect selection of the C library"; \
262 exit -1; \
263 fi; \
264 UCLIBC_CONFIG_FILE=$${SYSROOT_DIR}/usr/include/bits/uClibc_config.h ; \
265 $(call check_uclibc_feature,__ARCH_USE_MMU__,BR2_USE_MMU,$${UCLIBC_CONFIG_FILE},MMU support) ;\
266 $(call check_uclibc_feature,__UCLIBC_HAS_LFS__,,$${UCLIBC_CONFIG_FILE},Large file support) ;\
267 $(call check_uclibc_feature,__UCLIBC_HAS_IPV6__,,$${UCLIBC_CONFIG_FILE},IPv6 support) ;\
268 $(call check_uclibc_feature,__UCLIBC_HAS_RPC__,BR2_TOOLCHAIN_HAS_NATIVE_RPC,$${UCLIBC_CONFIG_FILE},RPC support) ;\
269 $(call check_uclibc_feature,__UCLIBC_HAS_LOCALE__,BR2_ENABLE_LOCALE,$${UCLIBC_CONFIG_FILE},Locale support) ;\
270 $(call check_uclibc_feature,__UCLIBC_HAS_WCHAR__,BR2_USE_WCHAR,$${UCLIBC_CONFIG_FILE},Wide char support) ;\
271 $(call check_uclibc_feature,__UCLIBC_HAS_THREADS__,BR2_TOOLCHAIN_HAS_THREADS,$${UCLIBC_CONFIG_FILE},Thread support) ;\
272 $(call check_uclibc_feature,__PTHREADS_DEBUG_SUPPORT__,BR2_TOOLCHAIN_HAS_THREADS_DEBUG,$${UCLIBC_CONFIG_FILE},Thread debugging support) ;\
273 $(call check_uclibc_feature,__UCLIBC_HAS_THREADS_NATIVE__,BR2_TOOLCHAIN_HAS_THREADS_NPTL,$${UCLIBC_CONFIG_FILE},NPTL thread support)
276 # Check that the Buildroot configuration of the ABI matches the
277 # configuration of the external toolchain.
279 # $1: cross-gcc path
280 # $2: cross-readelf path
282 check_arm_abi = \
283 __CROSS_CC=$(strip $1) ; \
284 __CROSS_READELF=$(strip $2) ; \
285 EXT_TOOLCHAIN_TARGET=`LANG=C $${__CROSS_CC} -v 2>&1 | grep ^Target | cut -f2 -d ' '` ; \
286 if ! echo $${EXT_TOOLCHAIN_TARGET} | grep -qE 'eabi(hf)?$$' ; then \
287 echo "External toolchain uses the unsuported OABI" ; \
288 exit 1 ; \
289 fi ; \
290 if ! echo 'int main(void) {}' | $${__CROSS_CC} -x c -o $(BUILD_DIR)/.br-toolchain-test.tmp - ; then \
291 rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*; \
292 abistr_$(BR2_ARM_EABI)='EABI'; \
293 abistr_$(BR2_ARM_EABIHF)='EABIhf'; \
294 echo "Incorrect ABI setting: $${abistr_y} selected, but toolchain is incompatible"; \
295 exit 1 ; \
296 fi ; \
297 rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*
300 # Check that the external toolchain supports C++
302 # $1: cross-g++ path
304 check_cplusplus = \
305 __CROSS_CXX=$(strip $1) ; \
306 $${__CROSS_CXX} -v > /dev/null 2>&1 ; \
307 if test $$? -ne 0 ; then \
308 echo "C++ support is selected but is not available in external toolchain" ; \
309 exit 1 ; \
314 # Check that the external toolchain supports Fortran
316 # $1: cross-gfortran path
318 check_fortran = \
319 __CROSS_FC=$(strip $1) ; \
320 __o=$(BUILD_DIR)/.br-toolchain-test-fortran.tmp ; \
321 printf 'program hello\n\tprint *, "Hello Fortran!\\n"\nend program hello\n' | \
322 $${__CROSS_FC} -x f95 -o $${__o} - ; \
323 if test $$? -ne 0 ; then \
324 rm -f $${__o}* ; \
325 echo "Fortran support is selected but is not available in external toolchain" ; \
326 exit 1 ; \
327 fi ; \
328 rm -f $${__o}* \
331 # Check that the cross-compiler given in the configuration exists
333 # $1: cross-gcc path
335 check_cross_compiler_exists = \
336 __CROSS_CC=$(strip $1) ; \
337 $${__CROSS_CC} -v > /dev/null 2>&1 ; \
338 if test $$? -ne 0 ; then \
339 echo "Cannot execute cross-compiler '$${__CROSS_CC}'" ; \
340 exit 1 ; \
344 # Check for toolchains known not to work with Buildroot.
345 # - For the Angstrom toolchains, we check by looking at the vendor part of
346 # the host tuple.
347 # - Exclude distro-class toolchains which are not relocatable.
348 # - Exclude broken toolchains which return "libc.a" with -print-file-name.
349 # - Exclude toolchains which doesn't support --sysroot option.
351 # $1: cross-gcc path
353 check_unusable_toolchain = \
354 __CROSS_CC=$(strip $1) ; \
355 vendor=`$${__CROSS_CC} -dumpmachine | cut -f2 -d'-'` ; \
356 if test "$${vendor}" = "angstrom" ; then \
357 echo "Angstrom toolchains are not pure toolchains: they contain" ; \
358 echo "many other libraries than just the C library, which makes" ; \
359 echo "them unsuitable as external toolchains for build systems" ; \
360 echo "such as Buildroot." ; \
361 exit 1 ; \
362 fi; \
363 with_sysroot=`$${__CROSS_CC} -v 2>&1 |sed -r -e '/.* --with-sysroot=([^[:space:]]+)[[:space:]].*/!d; s//\1/'`; \
364 if test "$${with_sysroot}" = "/" ; then \
365 echo "Distribution toolchains are unsuitable for use by Buildroot," ; \
366 echo "as they were configured in a way that makes them non-relocatable,"; \
367 echo "and contain a lot of pre-built libraries that would conflict with"; \
368 echo "the ones Buildroot wants to build."; \
369 exit 1; \
370 fi; \
371 libc_a_path=`$${__CROSS_CC} -print-file-name=libc.a` ; \
372 if test "$${libc_a_path}" = "libc.a" ; then \
373 echo "Unable to detect the toolchain sysroot, Buildroot cannot use this toolchain." ; \
374 exit 1 ; \
375 fi ; \
376 sysroot_dir="$(call toolchain_find_sysroot,$${__CROSS_CC})" ; \
377 if test -z "$${sysroot_dir}" ; then \
378 echo "External toolchain doesn't support --sysroot. Cannot use." ; \
379 exit 1 ; \
383 # Check if the toolchain has SSP (stack smashing protector) support
385 # $1: cross-gcc path
387 check_toolchain_ssp = \
388 __CROSS_CC=$(strip $1) ; \
389 __HAS_SSP=`echo 'void main(){}' | $${__CROSS_CC} -fstack-protector -x c - -o $(BUILD_DIR)/.br-toolchain-test.tmp >/dev/null 2>&1 && echo y` ; \
390 if [ "$(BR2_TOOLCHAIN_HAS_SSP)" != "y" -a "$${__HAS_SSP}" = "y" ] ; then \
391 echo "SSP support available in this toolchain, please enable BR2_TOOLCHAIN_EXTERNAL_HAS_SSP" ; \
392 exit 1 ; \
393 fi ; \
394 if [ "$(BR2_TOOLCHAIN_HAS_SSP)" = "y" -a "$${__HAS_SSP}" != "y" ] ; then \
395 echo "SSP support not available in this toolchain, please disable BR2_TOOLCHAIN_EXTERNAL_HAS_SSP" ; \
396 exit 1 ; \
397 fi ; \
398 rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*
401 # Generate gdbinit file for use with Buildroot
403 gen_gdbinit_file = \
404 mkdir -p $(STAGING_DIR)/usr/share/buildroot/ ; \
405 echo "set sysroot $(STAGING_DIR)" > $(STAGING_DIR)/usr/share/buildroot/gdbinit